package com.exh.bevel;

import android.app.Activity;
import android.graphics.Bitmap;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.Window;
import android.widget.ImageView;

public class BevelActivity extends Activity {

	public BevelActivity() {
	}
	
	@Override public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		requestWindowFeature(Window.FEATURE_PROGRESS);
		
		setContentView(R.layout.main);
		
		try {
			final ImageView			iv = (ImageView)findViewById(R.id.target);
			if (iv != null) {
				new Task(iv).execute(new Silo());
//				new Task(iv).execute(new Screenshot(this));
			}
		} catch (Exception ex) {
		}
	}
	
	// TASK
	// Offload all the rendering to a background thread
	// -----------------------
	private final static class Task extends AsyncTask<Generator, Float, Bitmap> implements ProgressReport {
		
		private final ImageView		mIv;
		
		Task(final ImageView iv) {
			mIv = iv;
		}
		
		public void setProgressReport(final float v) {
			try {
				publishProgress(new Float(v));
			} catch (Exception ex) {
			}
		}

		protected Bitmap doInBackground(Generator... roots) {
			if (roots == null) return null;
			for (int k=0; k<roots.length; k++) {
				if (roots[k] != null) {
					return roots[k].run(this);
				}
			}
			return null;
		}

		protected void onProgressUpdate(Float... values) {
			if (values == null || values[0] == null) return;
			
			try {
				final Activity		act = (Activity)(mIv.getContext());
				act.setProgress((int)(values[0]*10000));
			} catch (Exception ex) {
			}
		}

		protected void onPostExecute(Bitmap bm) {
			if (bm == null) System.out.println("Generated NO bitmap");
			else System.out.println("Generated bitmap w=" + bm.getWidth() + " h=" + bm.getHeight());

			try {
				mIv.setImageBitmap(bm);
				final Activity		act = (Activity)(mIv.getContext());
				act.setProgressBarVisibility(false);
			} catch (Exception ex) {
			}
		}
	}
}
