package com.exh.bevel;

import com.exh.math.primitive.Point3;
import com.exh.math.primitive.Quad;

/* Wrap up a quad with normal information.
 */
public class Surface {
	
	public final Quad			mQ;
	public Point3				mNormal = new Point3();
	// Each point has a normal that corresponds to whatever it's
	// connected to.
	public Point3[]				mPtNormal = Point3.newArray(4);

	public double				mL, mT, mR, mB;
	
	public Surface(final Quad q) {
		mQ = q;
		
		mL = mR = mQ.mPt[0].x;
		mT = mB = mQ.mPt[0].y;
		for (int k=1; k<mQ.mPt.length; k++) {
			final Point3		pt = mQ.mPt[k];
			mL = Math.min(mL, pt.x);
			mT = Math.min(mT, pt.y);
			mR = Math.max(mR, pt.x);
			mB = Math.max(mB, pt.y);
		}
	}

}
