package com.exh.math;

import com.exh.math.primitive.Point3;
import com.exh.math.primitive.Segment;

// Distance from point to line segment, 3D
// from http://www.softsurfer.com/Archive/algorithm_0102/#dist_Point_to_Segment()
public class PtToSeg3 {

	private final Point3		mV = new Point3(),
								mW = new Point3(),
								mPb = new Point3();
	
	public double on(final Point3 pt, final Segment seg, final Point3 out) {
		mV.sub(seg.mPt[1], seg.mPt[0]);
		mW.sub(pt, seg.mPt[0]);
		final double		c1 = mW.dot3(mV);
		if (c1 <= 0) {
			if (out != null) out.set(seg.mPt[0]);
			return pt.dist3(seg.mPt[0]);
		}
		
		final double		c2 = mV.dot3(mV);
		if (c2 <= c1) {
			if (out != null) out.set(seg.mPt[1]);
			return pt.dist3(seg.mPt[1]);
		}

		final double		b = c1 / c2;
		mPb.set(seg.mPt[0]);
		mV.mult(b);
		mPb.add(mV);
		if (out != null) out.set(mPb);
		return pt.dist3(mPb);
	}

}
